package cofh.thermal.expansion.compat.jei.machine;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cofh.core.util.helpers.RenderHelper;
import cofh.lib.fluid.FluidIngredient;
import cofh.lib.util.helpers.StringHelper;
import cofh.thermal.core.ThermalCore;
import cofh.thermal.core.compat.jei.TCoreJeiPlugin;
import cofh.thermal.core.util.recipes.machine.BottlerRecipe;
import cofh.thermal.expansion.client.gui.machine.MachineBottlerScreen;
import cofh.thermal.lib.compat.jei.Drawables;
import cofh.thermal.lib.compat.jei.ThermalRecipeCategory;
import cofh.thermal.lib.util.recipes.ThermalRecipe;
import com.mojang.blaze3d.vertex.PoseStack;
import java.util.List;
import mezz.jei.api.forge.ForgeTypes;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.gui.builder.IRecipeSlotBuilder;
import mezz.jei.api.gui.drawable.IDrawable;
import mezz.jei.api.gui.drawable.IDrawableAnimated;
import mezz.jei.api.gui.drawable.IDrawableStatic;
import mezz.jei.api.gui.ingredient.IRecipeSlotsView;
import mezz.jei.api.helpers.IGuiHelper;
import mezz.jei.api.ingredients.IIngredientType;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.recipe.RecipeIngredientRole;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.level.block.Block;

public class BottlerRecipeCategory extends ThermalRecipeCategory<BottlerRecipe> {
  protected IDrawableStatic tankBackground;
  
  protected IDrawableStatic tankOverlay;
  
  public BottlerRecipeCategory(IGuiHelper guiHelper, ItemStack icon, ResourceLocation uid) {
    super(guiHelper, icon, uid);
    this
      
      .background = (IDrawable)guiHelper.drawableBuilder(MachineBottlerScreen.TEXTURE, 26, 11, 124, 62).addPadding(0, 0, 16, 24).build();
    this.name = (Component)StringHelper.getTextComponent(((Block)ThermalCore.BLOCKS.get("machine_bottler")).m_7705_());
    this.progressBackground = Drawables.getDrawables(guiHelper).getProgress(0);
    this.progressFluidBackground = Drawables.getDrawables(guiHelper).getProgressFill(1);
    this.speedBackground = Drawables.getDrawables(guiHelper).getScale(1);
    this.tankBackground = Drawables.getDrawables(guiHelper).getTank(1);
    this.tankOverlay = Drawables.getDrawables(guiHelper).getTankOverlay(1);
    this.progress = guiHelper.createAnimatedDrawable(Drawables.getDrawables(guiHelper).getProgressFill(0), 200, IDrawableAnimated.StartDirection.LEFT, false);
    this.progressFluid = guiHelper.createAnimatedDrawable(Drawables.getDrawables(guiHelper).getProgress(1), 200, IDrawableAnimated.StartDirection.LEFT, true);
    this.speed = guiHelper.createAnimatedDrawable(Drawables.getDrawables(guiHelper).getScaleFill(1), 400, IDrawableAnimated.StartDirection.TOP, true);
  }
  
  public Class<? extends BottlerRecipe> getRecipeClass() {
    return BottlerRecipe.class;
  }
  
  public void setRecipe(IRecipeLayoutBuilder builder, BottlerRecipe recipe, IFocusGroup focuses) {
    List<Ingredient> inputs = recipe.getInputItems();
    List<FluidIngredient> inputFluids = recipe.getInputFluids();
    List<ItemStack> outputs = recipe.getOutputItems();
    builder.addSlot(RecipeIngredientRole.INPUT, 52, 15)
      .addIngredients(inputs.get(0));
    ((IRecipeSlotBuilder)builder.addSlot(RecipeIngredientRole.OUTPUT, 115, 24)
      .addItemStack(outputs.get(0)))
      .addTooltipCallback(TCoreJeiPlugin.defaultOutputTooltip(((Float)recipe.getOutputItemChances().get(0)).floatValue()));
    ((IRecipeSlotBuilder)builder.addSlot(RecipeIngredientRole.INPUT, 25, 11)
      .addIngredients((IIngredientType)ForgeTypes.FLUID_STACK, List.of(((FluidIngredient)inputFluids.get(0)).getFluids())))
      .setFluidRenderer(TCoreJeiPlugin.tankSize(8000), false, 16, 40)
      .setOverlay((IDrawable)this.tankOverlay, 0, 0)
      .addTooltipCallback(TCoreJeiPlugin.defaultFluidTooltip());
  }
  
  public void draw(BottlerRecipe recipe, IRecipeSlotsView recipeSlotsView, PoseStack matrixStack, double mouseX, double mouseY) {
    super.draw((ThermalRecipe)recipe, recipeSlotsView, matrixStack, mouseX, mouseY);
    this.progressBackground.draw(matrixStack, 78, 24);
    this.tankBackground.draw(matrixStack, 24, 10);
    this.speedBackground.draw(matrixStack, 52, 34);
    if (!recipe.getInputFluids().isEmpty()) {
      RenderHelper.drawFluid(matrixStack, 78, 24, ((FluidIngredient)recipe.getInputFluids().get(0)).getFluids()[0], 24, 16);
      this.progressFluidBackground.draw(matrixStack, 78, 24);
      this.progressFluid.draw(matrixStack, 78, 24);
    } else {
      this.progress.draw(matrixStack, 78, 24);
    } 
    this.speed.draw(matrixStack, 52, 34);
  }
}
